Loading...
Searching...
No Matches
lahef: Partial factorization; used by hetrf
Dense LA » Linear system solvers » Symmetric/Hermitian indefinite » Auxiliary routines

## Functions

magma_int_t | magma_clahef_gpu (magma_uplo_t uplo, magma_int_t n, magma_int_t nb, magma_int_t *kb, magmaFloatComplex_ptr dA, magma_int_t ldda, magma_int_t *ipiv, magmaFloatComplex_ptr dW, magma_int_t lddw, magma_queue_t queues[], magma_int_t *info)
| CLAHEF computes a partial factorization of a complex Hermitian matrix A using the Bunch-Kaufman diagonal pivoting method.
magma_int_t | magma_dlasyf_gpu (magma_uplo_t uplo, magma_int_t n, magma_int_t nb, magma_int_t *kb, magmaDouble_ptr dA, magma_int_t ldda, magma_int_t *ipiv, magmaDouble_ptr dW, magma_int_t lddw, magma_queue_t queues[], magma_int_t *info)
| DLASYF computes a partial factorization of a real symmetric matrix A using the Bunch-Kaufman diagonal pivoting method.
magma_int_t | magma_slasyf_gpu (magma_uplo_t uplo, magma_int_t n, magma_int_t nb, magma_int_t *kb, magmaFloat_ptr dA, magma_int_t ldda, magma_int_t *ipiv, magmaFloat_ptr dW, magma_int_t lddw, magma_queue_t queues[], magma_int_t *info)
| SLASYF computes a partial factorization of a real symmetric matrix A using the Bunch-Kaufman diagonal pivoting method.
magma_int_t | magma_zlahef_gpu (magma_uplo_t uplo, magma_int_t n, magma_int_t nb, magma_int_t *kb, magmaDoubleComplex_ptr dA, magma_int_t ldda, magma_int_t *ipiv, magmaDoubleComplex_ptr dW, magma_int_t lddw, magma_queue_t queues[], magma_int_t *info)
| ZLAHEF computes a partial factorization of a complex Hermitian matrix A using the Bunch-Kaufman diagonal pivoting method.

## Detailed Description

## Function Documentation

## magma_clahef_gpu()

magma_int_t magma_clahef_gpu | ( | magma_uplo_t | uplo,
|  | magma_int_t | n,
|  | magma_int_t | nb,
|  | magma_int_t * | kb,
|  | magmaFloatComplex_ptr | dA,
|  | magma_int_t | ldda,
|  | magma_int_t * | ipiv,
|  | magmaFloatComplex_ptr | dW,
|  | magma_int_t | lddw,
|  | magma_queue_t | queues[],
|  | magma_int_t * | info )

CLAHEF computes a partial factorization of a complex Hermitian matrix A using the Bunch-Kaufman diagonal pivoting method.

The partial factorization has the form:

A = ( I U12 ) ( A11 0 ) ( I 0 ) if UPLO = MagmaUpper, or: ( 0 U22 ) ( 0 D ) ( U12' U22' )

A = ( L11 0 ) ( D 0 ) ( L11' L21' ) if UPLO = MagmaLower ( L21 I ) ( 0 A22 ) ( 0 I )

where the order of D is at most NB. The actual order is returned in the argument KB, and is either NB or NB-1, or N if N <= NB. Note that U' denotes the conjugate transpose of U.

CLAHEF is an auxiliary routine called by CHETRF. It uses blocked code (calling Level 3 BLAS) to update the submatrix A11 (if UPLO = MagmaUpper) or A22 (if UPLO = MagmaLower).

Parameters

  [in]

  uplo

  CHARACTER Specifies whether the upper or lower triangular part of the Hermitian matrix A is stored:
  - = MagmaUpper: Upper triangular
  - = MagmaLower: Lower triangular

  [in] | n | INTEGER The order of the matrix A. N >= 0.
  [in] | nb | INTEGER The maximum number of columns of the matrix A that should be factored. NB should be at least 2 to allow for 2-by-2 pivot blocks.
  [out] | kb | INTEGER The number of columns of A that were actually factored. KB is either NB-1 or NB, or N if N <= NB.

  [in,out]

  dA

  COMPLEX array on GPU, dimension (LDDA,N) On entry, the Hermitian matrix A. If UPLO = MagmaUpper, the leading n-by-n upper triangular part of A contains the upper triangular part of the matrix A, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading n-by-n lower triangular part of A contains the lower triangular part of the matrix A, and the strictly upper triangular part of A is not referenced. On exit, A contains details of the partial factorization.

  [in] | ldda | INTEGER The leading dimension of the array A. LDDA >= max(1,N).

  [out]

  ipiv

  INTEGER array, dimension (N) Details of the interchanges and the block structure of D. If UPLO = MagmaUpper, only the last KB elements of ipiv are set; if UPLO = MagmaLower, only the first KB elements are set.
  If ipiv(k) > 0, then rows and columns k and ipiv(k) were interchanged and D(k,k) is a 1-by-1 diagonal block. If UPLO = MagmaUpper and ipiv(k) = ipiv(k-1) < 0, then rows and columns k-1 and -ipiv(k) were interchanged and D(k-1:k,k-1:k) is a 2-by-2 diagonal block. If UPLO = MagmaLower and ipiv(k) = ipiv(k+1) < 0, then rows and columns k+1 and -ipiv(k) were interchanged and D(k:k+1,k:k+1) is a 2-by-2 diagonal block.

  [out] | dW | (workspace) COMPLEX array, dimension (LDDW,NB)
  [in] | lddw | INTEGER The leading dimension of the array W. LDDW >= max(1,N).
  [in] | queues | magma_queue_t queues contain the queues used for the partial factorization. Currently, only one queue is used.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - > 0: if INFO = k, D(k,k) is exactly zero. The factorization has been completed, but the block diagonal matrix D is exactly singular.

## magma_dlasyf_gpu()

magma_int_t magma_dlasyf_gpu | ( | magma_uplo_t | uplo,
|  | magma_int_t | n,
|  | magma_int_t | nb,
|  | magma_int_t * | kb,
|  | magmaDouble_ptr | dA,
|  | magma_int_t | ldda,
|  | magma_int_t * | ipiv,
|  | magmaDouble_ptr | dW,
|  | magma_int_t | lddw,
|  | magma_queue_t | queues[],
|  | magma_int_t * | info )

DLASYF computes a partial factorization of a real symmetric matrix A using the Bunch-Kaufman diagonal pivoting method.

The partial factorization has the form:

A = ( I U12 ) ( A11 0 ) ( I 0 ) if UPLO = MagmaUpper, or: ( 0 U22 ) ( 0 D ) ( U12' U22' )

A = ( L11 0 ) ( D 0 ) ( L11' L21' ) if UPLO = MagmaLower ( L21 I ) ( 0 A22 ) ( 0 I )

where the order of D is at most NB. The actual order is returned in the argument KB, and is either NB or NB-1, or N if N <= NB. Note that U' denotes the conjugate transpose of U.

DLASYF is an auxiliary routine called by DSYTRF. It uses blocked code (calling Level 3 BLAS) to update the submatrix A11 (if UPLO = MagmaUpper) or A22 (if UPLO = MagmaLower).

Parameters

  [in]

  uplo

  CHARACTER Specifies whether the upper or lower triangular part of the symmetric matrix A is stored:
  - = MagmaUpper: Upper triangular
  - = MagmaLower: Lower triangular

  [in] | n | INTEGER The order of the matrix A. N >= 0.
  [in] | nb | INTEGER The maximum number of columns of the matrix A that should be factored. NB should be at least 2 to allow for 2-by-2 pivot blocks.
  [out] | kb | INTEGER The number of columns of A that were actually factored. KB is either NB-1 or NB, or N if N <= NB.

  [in,out]

  dA

  DOUBLE PRECISION array on GPU, dimension (LDDA,N) On entry, the symmetric matrix A. If UPLO = MagmaUpper, the leading n-by-n upper triangular part of A contains the upper triangular part of the matrix A, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading n-by-n lower triangular part of A contains the lower triangular part of the matrix A, and the strictly upper triangular part of A is not referenced. On exit, A contains details of the partial factorization.

  [in] | ldda | INTEGER The leading dimension of the array A. LDDA >= max(1,N).

  [out]

  ipiv

  INTEGER array, dimension (N) Details of the interchanges and the block structure of D. If UPLO = MagmaUpper, only the last KB elements of ipiv are set; if UPLO = MagmaLower, only the first KB elements are set.
  If ipiv(k) > 0, then rows and columns k and ipiv(k) were interchanged and D(k,k) is a 1-by-1 diagonal block. If UPLO = MagmaUpper and ipiv(k) = ipiv(k-1) < 0, then rows and columns k-1 and -ipiv(k) were interchanged and D(k-1:k,k-1:k) is a 2-by-2 diagonal block. If UPLO = MagmaLower and ipiv(k) = ipiv(k+1) < 0, then rows and columns k+1 and -ipiv(k) were interchanged and D(k:k+1,k:k+1) is a 2-by-2 diagonal block.

  [out] | dW | (workspace) DOUBLE PRECISION array, dimension (LDDW,NB)
  [in] | lddw | INTEGER The leading dimension of the array W. LDDW >= max(1,N).
  [in] | queues | magma_queue_t queues contain the queues used for the partial factorization. Currently, only one queue is used.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - > 0: if INFO = k, D(k,k) is exactly zero. The factorization has been completed, but the block diagonal matrix D is exactly singular.

## magma_slasyf_gpu()

magma_int_t magma_slasyf_gpu | ( | magma_uplo_t | uplo,
|  | magma_int_t | n,
|  | magma_int_t | nb,
|  | magma_int_t * | kb,
|  | magmaFloat_ptr | dA,
|  | magma_int_t | ldda,
|  | magma_int_t * | ipiv,
|  | magmaFloat_ptr | dW,
|  | magma_int_t | lddw,
|  | magma_queue_t | queues[],
|  | magma_int_t * | info )

SLASYF computes a partial factorization of a real symmetric matrix A using the Bunch-Kaufman diagonal pivoting method.

The partial factorization has the form:

A = ( I U12 ) ( A11 0 ) ( I 0 ) if UPLO = MagmaUpper, or: ( 0 U22 ) ( 0 D ) ( U12' U22' )

A = ( L11 0 ) ( D 0 ) ( L11' L21' ) if UPLO = MagmaLower ( L21 I ) ( 0 A22 ) ( 0 I )

where the order of D is at most NB. The actual order is returned in the argument KB, and is either NB or NB-1, or N if N <= NB. Note that U' denotes the conjugate transpose of U.

SLASYF is an auxiliary routine called by SSYTRF. It uses blocked code (calling Level 3 BLAS) to update the submatrix A11 (if UPLO = MagmaUpper) or A22 (if UPLO = MagmaLower).

Parameters

  [in]

  uplo

  CHARACTER Specifies whether the upper or lower triangular part of the symmetric matrix A is stored:
  - = MagmaUpper: Upper triangular
  - = MagmaLower: Lower triangular

  [in] | n | INTEGER The order of the matrix A. N >= 0.
  [in] | nb | INTEGER The maximum number of columns of the matrix A that should be factored. NB should be at least 2 to allow for 2-by-2 pivot blocks.
  [out] | kb | INTEGER The number of columns of A that were actually factored. KB is either NB-1 or NB, or N if N <= NB.

  [in,out]

  dA

  REAL array on GPU, dimension (LDDA,N) On entry, the symmetric matrix A. If UPLO = MagmaUpper, the leading n-by-n upper triangular part of A contains the upper triangular part of the matrix A, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading n-by-n lower triangular part of A contains the lower triangular part of the matrix A, and the strictly upper triangular part of A is not referenced. On exit, A contains details of the partial factorization.

  [in] | ldda | INTEGER The leading dimension of the array A. LDDA >= max(1,N).

  [out]

  ipiv

  INTEGER array, dimension (N) Details of the interchanges and the block structure of D. If UPLO = MagmaUpper, only the last KB elements of ipiv are set; if UPLO = MagmaLower, only the first KB elements are set.
  If ipiv(k) > 0, then rows and columns k and ipiv(k) were interchanged and D(k,k) is a 1-by-1 diagonal block. If UPLO = MagmaUpper and ipiv(k) = ipiv(k-1) < 0, then rows and columns k-1 and -ipiv(k) were interchanged and D(k-1:k,k-1:k) is a 2-by-2 diagonal block. If UPLO = MagmaLower and ipiv(k) = ipiv(k+1) < 0, then rows and columns k+1 and -ipiv(k) were interchanged and D(k:k+1,k:k+1) is a 2-by-2 diagonal block.

  [out] | dW | (workspace) REAL array, dimension (LDDW,NB)
  [in] | lddw | INTEGER The leading dimension of the array W. LDDW >= max(1,N).
  [in] | queues | magma_queue_t queues contain the queues used for the partial factorization. Currently, only one queue is used.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - > 0: if INFO = k, D(k,k) is exactly zero. The factorization has been completed, but the block diagonal matrix D is exactly singular.

## magma_zlahef_gpu()

magma_int_t magma_zlahef_gpu | ( | magma_uplo_t | uplo,
|  | magma_int_t | n,
|  | magma_int_t | nb,
|  | magma_int_t * | kb,
|  | magmaDoubleComplex_ptr | dA,
|  | magma_int_t | ldda,
|  | magma_int_t * | ipiv,
|  | magmaDoubleComplex_ptr | dW,
|  | magma_int_t | lddw,
|  | magma_queue_t | queues[],
|  | magma_int_t * | info )

ZLAHEF computes a partial factorization of a complex Hermitian matrix A using the Bunch-Kaufman diagonal pivoting method.

The partial factorization has the form:

A = ( I U12 ) ( A11 0 ) ( I 0 ) if UPLO = MagmaUpper, or: ( 0 U22 ) ( 0 D ) ( U12' U22' )

A = ( L11 0 ) ( D 0 ) ( L11' L21' ) if UPLO = MagmaLower ( L21 I ) ( 0 A22 ) ( 0 I )

where the order of D is at most NB. The actual order is returned in the argument KB, and is either NB or NB-1, or N if N <= NB. Note that U' denotes the conjugate transpose of U.

ZLAHEF is an auxiliary routine called by ZHETRF. It uses blocked code (calling Level 3 BLAS) to update the submatrix A11 (if UPLO = MagmaUpper) or A22 (if UPLO = MagmaLower).

Parameters

  [in]

  uplo

  CHARACTER Specifies whether the upper or lower triangular part of the Hermitian matrix A is stored:
  - = MagmaUpper: Upper triangular
  - = MagmaLower: Lower triangular

  [in] | n | INTEGER The order of the matrix A. N >= 0.
  [in] | nb | INTEGER The maximum number of columns of the matrix A that should be factored. NB should be at least 2 to allow for 2-by-2 pivot blocks.
  [out] | kb | INTEGER The number of columns of A that were actually factored. KB is either NB-1 or NB, or N if N <= NB.

  [in,out]

  dA

  COMPLEX*16 array on GPU, dimension (LDDA,N) On entry, the Hermitian matrix A. If UPLO = MagmaUpper, the leading n-by-n upper triangular part of A contains the upper triangular part of the matrix A, and the strictly lower triangular part of A is not referenced. If UPLO = MagmaLower, the leading n-by-n lower triangular part of A contains the lower triangular part of the matrix A, and the strictly upper triangular part of A is not referenced. On exit, A contains details of the partial factorization.

  [in] | ldda | INTEGER The leading dimension of the array A. LDDA >= max(1,N).

  [out]

  ipiv

  INTEGER array, dimension (N) Details of the interchanges and the block structure of D. If UPLO = MagmaUpper, only the last KB elements of ipiv are set; if UPLO = MagmaLower, only the first KB elements are set.
  If ipiv(k) > 0, then rows and columns k and ipiv(k) were interchanged and D(k,k) is a 1-by-1 diagonal block. If UPLO = MagmaUpper and ipiv(k) = ipiv(k-1) < 0, then rows and columns k-1 and -ipiv(k) were interchanged and D(k-1:k,k-1:k) is a 2-by-2 diagonal block. If UPLO = MagmaLower and ipiv(k) = ipiv(k+1) < 0, then rows and columns k+1 and -ipiv(k) were interchanged and D(k:k+1,k:k+1) is a 2-by-2 diagonal block.

  [out] | dW | (workspace) COMPLEX*16 array, dimension (LDDW,NB)
  [in] | lddw | INTEGER The leading dimension of the array W. LDDW >= max(1,N).
  [in] | queues | magma_queue_t queues contain the queues used for the partial factorization. Currently, only one queue is used.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - > 0: if INFO = k, D(k,k) is exactly zero. The factorization has been completed, but the block diagonal matrix D is exactly singular.